# Gio::Seekable Class Reference
[Stream Classes]

Stream seeking interface. More...

Inherits Glib::Interface.

Inherited by Gio::FileInputStream, Gio::FileIOStream, Gio::FileOutputStream, Gio::MemoryInputStream, and Gio::MemoryOutputStream.

Collaboration diagram for Gio::Seekable:
[legend]

List of all members.

## Public Member Functions

virtual | ~Seekable ()
GSeekable* | gobj ()
| Provides access to the underlying C GObject.
const GSeekable* | gobj () const
| Provides access to the underlying C GObject.
goffset | tell () const
| Tells the current position within the stream.
bool | can_seek () const
| Tests if the stream supports the SeekableIface.
bool | seek (goffset offset, Glib::SeekType type, const Glib::RefPtr< Cancellable >& cancellable)
| Seeks in the stream by the given offset, modified by type.
bool | seek (goffset offset, Glib::SeekType type)
| Seeks in the stream by the given offset, modified by type .
bool | can_truncate () const
| Tests if the stream can be truncated.
bool | truncate (goffset offset, const Glib::RefPtr< Cancellable >& cancellable)
| Truncates a stream with a given offset.
bool | truncate (goffset offset)
| Truncates a stream with a given offset.

## Static Public Member Functions

static void | add_interface (GType gtype_implementer)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gio::Seekable > | wrap (GSeekable* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Stream seeking interface.

Seekable is implemented by streams (implementations of InputStream or OutputStream) that support seeking. To find the position of a stream, use tell(). To find out if a stream supports seeking, use can_seek(). To position a stream, use seek(). To find out if a stream supports truncating, use can_truncate(). To truncate a stream, use truncate().

Since glibmm 2.16:

## Constructor & Destructor Documentation

virtual Gio::Seekable::~Seekable | ( |  | ) | `[virtual]`

## Member Function Documentation

static void Gio::Seekable::add_interface | ( | GType | gtype_implementer | ) | `[static]`

bool Gio::Seekable::can_seek | ( |  | ) | const

Tests if the stream supports the SeekableIface.

Returns:
  `true` if seekable can be seeked. `false` otherwise.

bool Gio::Seekable::can_truncate | ( |  | ) | const

Tests if the stream can be truncated.

Returns:
  `true` if the stream can be truncated, `false` otherwise.

const GSeekable* Gio::Seekable::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gio::FileInputStream, Gio::FileIOStream, Gio::FileOutputStream, Gio::MemoryInputStream, and Gio::MemoryOutputStream.

GSeekable* Gio::Seekable::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gio::FileInputStream, Gio::FileIOStream, Gio::FileOutputStream, Gio::MemoryInputStream, and Gio::MemoryOutputStream.

bool Gio::Seekable::seek | ( | goffset | offset,
|  | Glib::SeekType | type |
| ) |  |  |

Seeks in the stream by the given offset, modified by type .

Parameters:

  | offset | A goffset.
  | type | A Glib::SeekType.

Returns:
  `true` if successful. If an error has occurred, this function will return `false`.

bool Gio::Seekable::seek | ( | goffset | offset,
|  | Glib::SeekType | type,
|  | const Glib::RefPtr< Cancellable >& | cancellable |
| ) |  |  |

Seeks in the stream by the given offset, modified by type.

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters:

  | offset | A goffset.
  | type | A SeekType.
  | cancellable | Cancellable object.

Returns:
  `true` if successful. If an error has occurred, this function will return `false` and set error appropriately if present.

goffset Gio::Seekable::tell | ( |  | ) | const

Tells the current position within the stream.

Returns:
  The offset from the beginning of the buffer.

bool Gio::Seekable::truncate | ( | goffset | offset | ) |

Truncates a stream with a given offset.

Parameters:

  | offset | A goffset.

Returns:
  `true` if successful. If an error has occured, this function will return `false`.

bool Gio::Seekable::truncate | ( | goffset | offset,
|  | const Glib::RefPtr< Cancellable >& | cancellable |
| ) |  |  |

Truncates a stream with a given offset.

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED. If an operation was partially finished when the operation was cancelled the partial result will be returned, without an error.

Parameters:

  | offset | A goffset.
  | cancellable | Cancellable object.

Returns:
  `true` if successful. If an error has occurred, this function will return `false` and set error appropriately if present.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::Seekable > wrap | ( | GSeekable * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- giomm/seekable.h